package org.example;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;

public class FindNodeByPath {

    public JsonNode findNestedNode(final String sourceJsonString, final String... paths) {
        ObjectMapper ob = new ObjectMapper();

        boolean found = false;
        JsonNode foundNode ;
        int i = 0;

        try {
            JsonNode rootNode = ob.readTree(sourceJsonString);
            foundNode = rootNode.path(paths[0]);
            while (!found) {
                if (foundNode.isMissingNode()) {
                    throw new IllegalArgumentException("Not found " + paths[i]);
                } else {
                    if (foundNode.isContainerNode()) {
                        if( i + 1 >= paths.length){
                            break;
                        }
                        foundNode = foundNode.path(paths[i + 1]);
                    } else {
                        found = true;
                    }
                }
                i++;
            }


        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
        return foundNode;
    }

}